## pdal 2.2.0+ds

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 3.5)

project(PDAL VERSION 2.2.0 LANGUAGES CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# PDAL general settings
#------------------------------------------------------------------------------

#
# Must be changed if there is an ABI change.  This builds the SONAME
# that's embedded in the library itself.
#
set(PDAL_SOLIB_MAJOR 12)
#
# Change if there's a new release with no ABI change
#
set(PDAL_SOLIB_MINOR 0)
#
# Build number.  Increment for builds within minor versions.  Probably
# always 0 for PDAL
#
set(PDAL_SOLIB_BUILD 0)


set(PDAL_API_VERSION ${PDAL_SOLIB_MAJOR})
set(PDAL_BUILD_VERSION
    "${PDAL_SOLIB_MAJOR}.${PDAL_SOLIB_MINOR}.${PDAL_SOLIB_BUILD}")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Name of C++ library

#
# To facilitate one-library linking, we do special things for various platforms.
#
# On Linux we install a linker script that we call libpdalcpp.so and it
# in turn links libpdal_base.so and libpdal_util.so
#
# On OSX we reexport the symbols from libpdal_util.dylib into libpdalcpp.dylib
# See below for the rest of the magic.
#
if (APPLE OR WIN32)
    set(PDAL_BASE_LIB_NAME pdalcpp)
else()
    set(PDAL_BASE_LIB_NAME pdal_base)
endif()
set(PDAL_LIB_NAME pdalcpp)
set(PDAL_UTIL_LIB_NAME pdal_util)
set(PDAL_BOOST_LIB_NAME pdal_boost)
set(PDAL_KAZHDAN_LIB_NAME pdal_kazhdan)
set(PDAL_TEST_SUPPORT_OBJS pdal_test_support)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(PDAL_OUTPUT_LIB_DIR "${PDAL_BINARY_DIR}/${PDAL_LIB_INSTALL_DIR}")
set(PDAL_OUTPUT_BIN_DIR "${PDAL_BINARY_DIR}/${PDAL_BIN_INSTALL_DIR}")

# allow override of PDAL_PLUGIN_INSTALL_PATH path
if (NOT PDAL_PLUGIN_INSTALL_PATH)
    if (WIN32)
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_BIN_INSTALL_DIR}")
    else()
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_LIB_INSTALL_DIR}")
    endif()
endif()
file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
file(MAKE_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")

include(${PDAL_CMAKE_DIR}/rpath.cmake)

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
    "${PDAL_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DPDAL_DLL_EXPORT=1")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
  # ---[ Windows requires DLLs (shared libraries) to be installed in
  # ---[ the same directory as executables
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
endif(WIN32)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
if(WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
else()
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
endif()

# Choose package components

include(${PDAL_CMAKE_DIR}/options.cmake)

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

set(PDAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})

#------------------------------------------------------------------------------
#  Dependencies.
#------------------------------------------------------------------------------

include(${PDAL_CMAKE_DIR}/gdal.cmake)
include(${PDAL_CMAKE_DIR}/geotiff.cmake)  # Optional (not really)
include(${PDAL_CMAKE_DIR}/lazperf.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/laszip.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/zlib.cmake)
include(${PDAL_CMAKE_DIR}/lzma.cmake)
include(${PDAL_CMAKE_DIR}/zstd.cmake)
include(${PDAL_CMAKE_DIR}/test.cmake)
include(${PDAL_CMAKE_DIR}/ctest.cmake)
include(${PDAL_CMAKE_DIR}/libxml2.cmake)
include(${PDAL_CMAKE_DIR}/dimension.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)
include(${PDAL_CMAKE_DIR}/nlohmann.cmake)
include(${PDAL_CMAKE_DIR}/openssl.cmake) # Optional

#------------------------------------------------------------------------------
# generate the pdal_features.hpp header
#------------------------------------------------------------------------------

# from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

configure_file(
  "${PROJECT_SOURCE_DIR}/gitsha.cpp.in"
  "${PROJECT_SOURCE_DIR}/pdal/gitsha.cpp")

# needs to come before configuration of pdal_features
if(APPLE)
    option(PDAL_BUNDLE "Create PDAL as Application Bundle on OSX" FALSE)
    if (PDAL_BUNDLE)
        set(PDAL_APP_BUNDLE 1)
    endif()
endif()

set(pdal_features_hpp_in "${CMAKE_CURRENT_SOURCE_DIR}/pdal_features.hpp.in")
set(pdal_features_hpp
    "${CMAKE_CURRENT_BINARY_DIR}/include/pdal/pdal_features.hpp")
configure_file(${pdal_features_hpp_in} ${pdal_features_hpp})

#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

# PDAL_TARGET_OBJECTS is used to collect the driver object libraries
set(PDAL_TARGET_OBJECTS "")

if (WITH_TESTS)
    enable_testing()
endif()

add_subdirectory(plugins)

#include_directories(vendor/pdalboost)
if (WITH_TESTS)
    include (${PDAL_CMAKE_DIR}/gtest.cmake)
    add_subdirectory(test)
endif()
add_subdirectory(dimbuilder)
add_subdirectory(vendor/pdalboost)
add_subdirectory(vendor/arbiter)
add_subdirectory(vendor/kazhdan)
add_subdirectory(pdal/util)
add_subdirectory(tools)
add_subdirectory(apps)
#
# On OSX we reexport the symbols in libpdal_util.dylib into libpdalcpp.dylib
# so that users only need link libpdalcpp.
#
if (APPLE)
    set(PDAL_REEXPORT "-Wl,-reexport_library,$<TARGET_FILE:${PDAL_UTIL_LIB_NAME}>")
    #
    # This allows the rpath reference for the reexported library (above) to
    # be found.
    #
    set(PDAL_LIBDIR "-L$<TARGET_FILE_DIR:${PDAL_UTIL_LIB_NAME}>")
endif()

file(GLOB BASE_SRCS
    ${PDAL_FILTERS_DIR}/*.cpp
    ${PDAL_IO_DIR}/*.cpp
    ${PDAL_KERNELS_DIR}/*.cpp
    ${PDAL_SRC_DIR}/*.cpp
    ${PDAL_SRC_DIR}/compression/*.cpp)
file(GLOB_RECURSE PRIVATE_SRCS
    ${PDAL_FILTERS_DIR}/private/*.cpp
    ${PDAL_IO_DIR}/private/*.cpp
    ${PDAL_KERNELS_DIR}/private/*.cpp
    ${PDAL_SRC_DIR}/private/*.cpp)
list(APPEND SRCS ${BASE_SRCS} ${PRIVATE_SRCS})

#
# Remove stuff we don't want to build.
#
if (NOT PDAL_HAVE_LIBXML2)
    file(GLOB XML_SRCS
        io/Ilvis2MetadataReader.cpp
        io/Ilvis2Metadata.cpp
        io/Ilvis2Reader.cpp
        ${PDAL_SRC_DIR}/DbWriter.cpp
        ${PDAL_SRC_DIR}/DbReader.cpp
        ${PDAL_SRC_DIR}/XMLSchema.cpp)
    list(REMOVE_ITEM SRCS ${XML_SRCS})
endif()
if (NOT PDAL_HAVE_ZSTD)
    file(GLOB ZSTD_SRCS
        ${PDAL_SRC_DIR}/compression/ZstdCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZSTD_SRCS})
endif()
if (NOT PDAL_HAVE_ZLIB)
    file(GLOB ZLIB_SRCS
        ${PDAL_SRC_DIR}/compression/DeflateCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZLIB_SRCS})
endif()
if (NOT PDAL_HAVE_LZMA)
    file(GLOB LZMA_SRCS
        ${PDAL_SRC_DIR}/compression/LzmaCompression.cpp)
    list(REMOVE_ITEM SRCS ${LZMA_SRCS})
endif()
if (NOT PDAL_HAVE_LAZPERF)
    file(GLOB LAZPERF_SRCS
        ${PDAL_SRC_DIR}/compression/LazPerfCompression.cpp
        ${PDAL_SRC_DIR}/compression/LazPerfVlrCompression.cpp)
    list(REMOVE_ITEM SRCS ${LAZPERF_SRCS})
endif()
if (GDAL_VERSION VERSION_LESS 3.0.0)
    file(GLOB PROJPIPELINE_FILTER_SRCS
        ${PDAL_FILTERS_DIR}/ProjPipelineFilter.cpp)
    list(REMOVE_ITEM SRCS ${PROJPIPELINE_FILTER_SRCS})
endif()
PDAL_ADD_LIBRARY(${PDAL_BASE_LIB_NAME} ${SRCS} ${RPLY_SRCS})

#
# Interface include directories allow downstream project to get the directory
# without specification.
#
target_include_directories(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
        ${ZSTD_INCLUDE_DIRS}
        ${NLOHMANN_INCLUDE_DIR}
        ${GDAL_INCLUDE_DIR}
        ${LASZIP_INCLUDE_DIR}
)
target_link_libraries(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${CMAKE_THREAD_LIBS_INIT}
        ${GDAL_LIBRARY}
        ${GEOTIFF_LIBRARY}
        ${LASZIP_LIBRARY}
        ${LIBXML2_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${LIBLZMA_LIBRARIES}
        ${ZSTD_LIBRARIES}
        ${WINSOCK_LIBRARY}
        ${PDAL_REEXPORT}
        ${PDAL_UTIL_LIB_NAME}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_KAZHDAN_LIB_NAME}
    INTERFACE
        ${PDAL_LIBDIR}
)
target_compile_definitions(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${LASZIP_DEFINES}
)
set_target_properties(${PDAL_BASE_LIB_NAME} PROPERTIES
    VERSION ${PDAL_BUILD_VERSION}
    SOVERSION ${PDAL_API_VERSION}
    CLEAN_DIRECT_OUTPUT 1)

# shut off -Wpedantic selectively
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" )
set_source_files_properties(filters/PoissonFilter.cpp PROPERTIES COMPILE_FLAGS -Wno-pedantic)
endif()

#
# On Linux, we install a linker script as libpdalcpp.so.  That file
# specifies linking in libpdal_base.so and libpdal_util.so.  This allows
# users to link a single library, libpdalcpp
#
if (UNIX AND NOT APPLE)
    set(LIBNAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PDAL_LIB_NAME})
    install(FILES ${LIBNAME} DESTINATION ${PDAL_LIB_INSTALL_DIR}
        RENAME ${LIBNAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

#
# Installation
#

#
# Only install compression headers if we're building with the particular
# compression type.
#
if (NOT PDAL_HAVE_ZSTD)
    set(ZSTD_EXCLUDES PATTERN pdal/compression/Zstd* EXCLUDE)
endif()
if (NOT PDAL_HAVE_ZLIB)
    set(ZLIB_EXCLUDES PATTERN pdal/compression/Deflate* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LZMA)
    set(LZMA_EXCLUDES PATTERN pdal/compression/Lzma* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LAZPERF)
    set(LAZPERF_EXCLUDES PATTERN pdal/compression/LazPerf* EXCLUDE)
endif()

install(DIRECTORY ${PDAL_INCLUDE_DIR}/pdal
    DESTINATION include
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "gitsha.h"
#    PATTERN "pdal/private" EXCLUDE
#    PATTERN "pdal/io/private" EXCLUDE
#    PATTERN "pdal/pdal/private" EXCLUDE
#    PATTERN "pdal/util/private" EXCLUDE
#    PATTERN "pdal/filters/private" EXCLUDE
#    ${ZSTD_EXCLUDES}
#    ${ZLIB_EXCLUDES}
#    ${LZMA_EXCLUDES}
#    ${LAZPERF_EXCLUDES}
)

install(DIRECTORY ${PDAL_KERNELS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_IO_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_FILTERS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)

install(FILES ${DIMENSION_OUTFILE} ${pdal_features_hpp}
  DESTINATION include/pdal
)

#
# CPACK
#
include (${PDAL_CMAKE_DIR}/cpack.cmake)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

export(
    TARGETS
        ${PDAL_BASE_LIB_NAME} ${PDAL_UTIL_LIB_NAME}
    FILE
        "${PDAL_BINARY_DIR}/PDALTargets.cmake")

install(

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build
OUTPUTDIR=/tmp/pdal-docs
DATE=$(shell date +'%y.%m.%d %H:%M:%S')

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest doxygen

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  pdf        to make PDF files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf $(OUTPUTDIR)/
	-rm -rf doxygen/xml*;
	-rm -rf doxygen/html*;

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PDAL.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PDAL.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/PDAL"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/PDAL"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

doxygen:
	cd ../ ; doxygen doc/doxygen/doxygen.conf; cd doc

clone: html
	-rm -rf $(OUTPUTDIR)
	git clone git@github.com:PDAL/pdal.github.io.git $(OUTPUTDIR)

publish: clone
	cp -r $(BUILDDIR)/html/* $(OUTPUTDIR)/
	cd $(OUTPUTDIR) ; git checkout master; git add  "*" ; git commit -m "update for $(DATE)" . ; git push

spell:
	$(SPHINXBUILD) -b spelling $(ALLSPHINXOPTS) -d $(BUILDDIR)/doctrees build/spelling

pdf:
	$(SPHINXBUILD) -b pdf $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
	@echo
	@echo "Build finished. The PDF files are in _build/pdf."

docker:
	docker run -v `pwd`/../:/data -w /data/doc pdal/docs make doxygen html latexpdf

=== plugins/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/test.cmake)

add_subdirectory(faux)
if(BUILD_PLUGIN_I3S)
    if(NOT ZLIB_FOUND)
        message(FATAL_ERROR "Can't build i3s and slpk plugins without zlib")
    endif()
    add_subdirectory(i3s)
endif()

if(BUILD_PLUGIN_CPD)
    add_subdirectory(cpd)
endif(BUILD_PLUGIN_CPD)

if(BUILD_PLUGIN_GEOWAVE)
    add_subdirectory(geowave)
endif(BUILD_PLUGIN_GEOWAVE)

if(BUILD_PLUGIN_ICEBRIDGE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build icebridge plugin without libxml2")
    endif()
    add_subdirectory(icebridge)
endif()

if(BUILD_PLUGIN_HDF)
    add_subdirectory(hdf)
endif()

if(BUILD_PLUGIN_MATLAB)
    add_subdirectory(matlab)
endif()

if(BUILD_PLUGIN_MBIO)
    add_subdirectory(mbio)
endif()

if(BUILD_PLUGIN_MRSID)
    add_subdirectory(mrsid)
endif()

if(BUILD_PLUGIN_NITF)
    add_subdirectory(nitf)
endif()

if(BUILD_PLUGIN_OCI)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build OCI plugin without libxml2")
    endif()
    add_subdirectory(oci)
endif()

if(BUILD_PLUGIN_PGPOINTCLOUD)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build pgpointcloud plugin without libxml2")
    endif()
    add_subdirectory(pgpointcloud)
endif()

if(BUILD_PLUGIN_OPENSCENEGRAPH)
    add_subdirectory(openscenegraph)
endif()

if(BUILD_PLUGIN_RDBLIB)
    add_subdirectory(rdb)
endif(BUILD_PLUGIN_RDBLIB)

if(BUILD_PLUGIN_RIVLIB)
    add_subdirectory(rxp)
endif(BUILD_PLUGIN_RIVLIB)

if (BUILD_PLUGIN_FBX)
    add_subdirectory(fbx)
endif()

if(BUILD_PLUGIN_TILEDB)
    add_subdirectory(tiledb)
endif()

if(BUILD_PLUGIN_E57)
    add_subdirectory(e57)
endif()

=== examples/writing-filter/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(FilterTutorial)

find_package(PDAL 1.9.0 REQUIRED CONFIG)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
add_library(pdal_plugin_filter_myfilter SHARED MyFilter.cpp)
target_link_libraries(pdal_plugin_filter_myfilter PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_filter_myfilter PRIVATE ${PDAL_INCLUDE_DIRS})
target_link_directories(pdal_plugin_filter_myfilter PRIVATE ${PDAL_LIBRARY_DIRS})

=== pdal/util/CMakeLists.txt ===
#
# Make sure we don't attempt to add a library more than once
#
get_property(EXISTS GLOBAL PROPERTY _UTIL_INCLUDED)
if(EXISTS)
    return()
endif()

include(${PDAL_CMAKE_DIR}/execinfo.cmake)
include(${PDAL_CMAKE_DIR}/unwind.cmake)

if(LIBUNWIND_FOUND)
    set(BACKTRACE_SOURCE BacktraceUnwind.cpp)
    set(BACKTRACE_LIBRARIES ${LIBUNWIND_LIBRARIES})
elseif(LIBEXECINFO_FOUND)
    set(BACKTRACE_SOURCE BacktraceExecinfo.cpp)
    set(BACKTRACE_LIBRARIES ${LIBEXECINFO_LIBRARIES})
else()
    set(BACKTRACE_SOURCE BacktraceNone.cpp)
endif()

set(PDAL_UTIL_SOURCES
    "${PDAL_UTIL_DIR}/Bounds.cpp"
    "${PDAL_UTIL_DIR}/Charbuf.cpp"
    "${PDAL_UTIL_DIR}/FileUtils.cpp"
    "${PDAL_UTIL_DIR}/Georeference.cpp"
    "${PDAL_UTIL_DIR}/ThreadPool.cpp"
    "${PDAL_UTIL_DIR}/Utils.cpp"
    "${PDAL_UTIL_DIR}/Backtrace.cpp"
    "${PDAL_UTIL_DIR}/private/${BACKTRACE_SOURCE}"
)

PDAL_ADD_FREE_LIBRARY(${PDAL_UTIL_LIB_NAME} SHARED ${PDAL_UTIL_SOURCES})
target_link_libraries(${PDAL_UTIL_LIB_NAME}
    PRIVATE
        ${BACKTRACE_LIBRARIES}
        ${PDAL_BOOST_LIB_NAME}
        ${CMAKE_DL_LIBS}
)
target_include_directories(${PDAL_UTIL_LIB_NAME} PRIVATE
    ${PDAL_VENDOR_DIR}/pdalboost)

set_target_properties(${PDAL_UTIL_LIB_NAME} PROPERTIES
    VERSION "${PDAL_BUILD_VERSION}"
    SOVERSION "${PDAL_API_VERSION}"
    CLEAN_DIRECT_OUTPUT 1)

set_property(GLOBAL PROPERTY _UTIL_INCLUDED TRUE)

=== plugins/e57/CMakeLists.txt ===

add_subdirectory(libE57Format)

PDAL_ADD_PLUGIN(e57plugin_reader reader e57
    FILES
        io/E57Reader.cpp
        io/Scan.cpp
        io/Utils.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
    LINK_WITH
        E57Format
    INCLUDES
        libE57Format/include
)
target_compile_definitions(${e57plugin_reader}	
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

PDAL_ADD_PLUGIN(e57plugin_writer writer e57
    FILES
        io/E57Writer.cpp
        io/Utils.cpp
        io/Uuid.cpp
    LINK_WITH
        E57Format
    INCLUDES
        libE57Format/include
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_e57_read_test
        FILES
            test/E57ReaderTest.cpp
            test/E57UtilsTest.cpp
            test/ScanTest.cpp
        LINK_WITH
            ${e57plugin_reader}
            E57Format
        INCLUDES
            libE57Format/include
    )

    PDAL_ADD_TEST(pdal_io_e57_write_test
        FILES
            test/E57WriterTest.cpp
            test/E57UuidTest.cpp
        LINK_WITH
            ${e57plugin_reader}
            ${e57plugin_writer}
            E57Format
        INCLUDES
            libE57Format/include
    )
endif()

=== plugins/i3s/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/zlib.cmake)

add_subdirectory(lepcc)

PDAL_ADD_PLUGIN(i3s_reader_libname reader i3s
    FILES
        io/I3SReader.cpp
        io/EsriUtil.cpp
        io/EsriReader.cpp
        io/Obb.cpp
        io/PageManager.cpp
        ${PDAL_SRC_DIR}/private/MathUtils.cpp
    LINK_WITH
        ${WINSOCK_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
)
target_compile_definitions(${i3s_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

PDAL_ADD_PLUGIN(slpk_reader_libname reader slpk
    FILES
        io/SlpkReader.cpp
        io/EsriUtil.cpp
        io/EsriReader.cpp
        io/Obb.cpp
        io/PageManager.cpp
        ${PDAL_SRC_DIR}/private/MathUtils.cpp
    LINK_WITH
        ${WINSOCK_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
)
target_compile_definitions(${slpk_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_slpk_reader_test
        FILES
            test/SlpkReaderTest.cpp
    )

    PDAL_ADD_TEST(pdal_i3s_obb_test
        FILES
            test/ObbTest.cpp
            io/Obb.cpp
            ${PDAL_SRC_DIR}/private/MathUtils.cpp
        INCLUDES
            ${NLOHMANN_INCLUDE_DIR}
            ${PDAL_VENDOR_DIR}/eigen
    )

    if (BUILD_I3S_TESTS)
        PDAL_ADD_TEST(pdal_io_i3s_reader_test
                FILES
                    test/i3sReaderTest.cpp
        )
    endif()
endif()

=== plugins/matlab/CMakeLists.txt ===
# Matlab plugin

include(${PDAL_CMAKE_DIR}/matlab.cmake)

#set(CMAKE_SKIP_RPATH true)
#if (LINUX)

#endif()

PDAL_ADD_PLUGIN(libname_writer writer matlab
    FILES
        ./filters/Script.cpp
        io/MatlabWriter.cpp
    LINK_WITH
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
)

PDAL_ADD_PLUGIN(libname_reader reader matlab
    FILES
        ./filters/Script.cpp
        io/MatlabReader.cpp
    LINK_WITH
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
)


PDAL_ADD_PLUGIN(matlab_libname filter matlab
    FILES
        ./filters/Environment.cpp
        ./filters/Script.cpp
        ./filters/MatlabFilter.cpp
    LINK_WITH
        ${Matlab_ENG_LIBRARY}
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_matlab_writer_test
        FILES
            test/MatlabWriterTest.cpp
        LINK_WITH
           ${libname_writer}
        INCLUDES
            ${PDAL_IO_DIR}
            ${Matlab_INCLUDE_DIR}
    )
    set_target_properties(pdal_io_matlab_writer_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}"
        BUILD_WITH_INSTALL_RPATH true
    )


    PDAL_ADD_TEST(pdal_io_matlab_reader_test
        FILES
            test/MatlabReaderTest.cpp
        LINK_WITH
           ${libname_reader}
        INCLUDES
            ${PDAL_IO_DIR}
            ${Matlab_INCLUDE_DIR}
    )
    set_target_properties(pdal_io_matlab_reader_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}"
        BUILD_WITH_INSTALL_RPATH true
    )

    PDAL_ADD_TEST(pdal_filters_matlab_test
        FILES
            ./filters/Script.cpp
            ./filters/Environment.cpp
            ./test/MatlabFilterTest.cpp
        LINK_WITH
            ${Matlab_ENG_LIBRARY}
            ${Matlab_MX_LIBRARY}
            ${Matlab_MAT_LIBRARY}
        INCLUDES
            ${ROOT_DIR}
            ${Matlab_INCLUDE_DIR}
    )
    set_target_properties(pdal_filters_matlab_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}:${CMAKE_LIBRARY_OUTPUT_DIRECTORY}"
        BUILD_WITH_INSTALL_RPATH true
    )

endif()

=== plugins/oci/CMakeLists.txt ===
#
# Oracle OCI plugin CMake configuration
#
find_package(Oracle REQUIRED)

set(OCI_CONNECTION "scott/tiger@localhost/test" CACHE STRING
    "OCI connection string <username/password@instance>")
#
# OCI Reader
#
PDAL_ADD_PLUGIN(reader_libname reader oci
    FILES
        io/OciCommon.cpp
        io/OciReader.cpp
        io/OciWrapper.cpp
    LINK_WITH
        ${ORACLE_LIBRARY}
        ${GDAL_LIBRARY}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${ORACLE_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
)
#
# OCI Writer
#
PDAL_ADD_PLUGIN(writer_libname writer oci
    FILES
        io/OciCommon.cpp
        io/OciWrapper.cpp
        io/OciWriter.cpp
    LINK_WITH
        ${ORACLE_LIBRARY}
        ${GDAL_LIBRARY}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${ORACLE_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
)
#
# OCI tests
#
if(BUILD_OCI_TESTS)
    PDAL_ADD_TEST(ocitest
        FILES
            test/OCITest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
            ${GDAL_LIBRARY}
            ${LIBXML2_LIBRARY}
        INCLUDES
            ${ORACLE_INCLUDE_DIR}
            ${LIBXML2_INCLUDE_DIR}
    )
endif()

=== plugins/pgpointcloud/CMakeLists.txt ===
#
# PgPointCloud plugin CMake configuration
#
include(${PDAL_CMAKE_DIR}/postgres.cmake)

#
# PgPointCloud Reader
#
PDAL_ADD_PLUGIN(reader_libname reader pgpointcloud
    FILES
        io/PgReader.cpp
    LINK_WITH
        ${POSTGRESQL_LIBRARIES}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
)

#
# PgPointCloud Writer
#
PDAL_ADD_PLUGIN(writer_libname writer pgpointcloud
    FILES
        io/PgWriter.cpp
    LINK_WITH
        ${POSTGRESQL_LIBRARIES}
        ${LIBXML2_LIBRARIES}
    INCLUDES
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
)
#
# PgPointCloud tests
#
if (BUILD_PGPOINTCLOUD_TESTS)
	set(PGPOINTCLOUD_TEST_DB_USER $ENV{PGUSER} CACHE STRING
            "Postgres test database user, must be able to create databases")
	set(PGPOINTCLOUD_TEST_DB_HOST $ENV{PGHOST} CACHE STRING
            "Postgres test database host")
	set(PGPOINTCLOUD_TEST_DB_PORT $ENV{PGPORT} CACHE STRING
            "Postgres test database port")
	set(PGPOINTCLOUD_TEST_DB_NAME template1 CACHE STRING
            "Postgres master database name, must exist")
	set(PGPOINTCLOUD_TEST_DB_TEMPNAME pdal_test_tmp CACHE STRING
            "Postgres test database temp database name")

	configure_file(
        test/Pgtest-Support.hpp.in
        ${CMAKE_CURRENT_BINARY_DIR}/include/Pgtest-Support.hpp
    )

	PDAL_ADD_TEST(pgpointcloudtest
        FILES
            test/PgpointcloudWriterTest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
            ${POSTGRESQL_LIBRARIES}
        INCLUDES
            ${CMAKE_CURRENT_BINARY_DIR}/include
    )
endif()

=== plugins/rdb/CMakeLists.txt ===

find_package(rdb COMPONENTS REQUIRED)
set_package_properties(rdb PROPERTIES
    TYPE REQUIRED
    PURPOSE "Read data from RIEGL databases"
    )

PDAL_ADD_PLUGIN(libname reader rdb
    FILES
        io/RdbPointcloud.cpp
        io/RdbReader.cpp
    LINK_WITH
        rdbcpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${RDB_INCLUDE_CPP_DIR}
)
target_include_directories(${libname} PRIVATE "${PDAL_VENDOR_DIR}/eigen")

# windows requires explicit linking against
# rdbcpp
if (WIN32)
	set(RDB_LIBRARY "rdbcpp")
endif()

set(RDB_TEST_NAME pdal_io_rdb_reader_test)
option(BUILD_RDBLIB_TESTS "Build rdblib tests" ON)
if (WITH_TESTS)
if (BUILD_RDBLIB_TESTS)
    configure_file(
        test/Config.hpp.in
        "${CMAKE_CURRENT_BINARY_DIR}/test/Config.hpp"
    )

    PDAL_ADD_TEST(${RDB_TEST_NAME}
        FILES
            test/RdbReaderTest.cpp
        LINK_WITH
            ${libname} ${RDB_LIBRARY}
        INCLUDES
            ${PROJECT_BINARY_DIR}/plugins/rdb/test
            ${PROJECT_SOURCE_DIR}/plugins/rdb/io
            ${RDB_INCLUDE_CPP_DIR}
            ${PDAL_VENDOR_DIR}/eigen

    )
endif()
endif()

=== plugins/tiledb/CMakeLists.txt ===
#
# TileDB plugin CMake configuration
#
include(${PDAL_CMAKE_DIR}/tiledb.cmake)
if (NOT TILEDB_FOUND)
    message(FATAL_ERROR "Can't find TileDB support required.")
endif()

#
# TileDB Reader
#
PDAL_ADD_PLUGIN(reader_libname reader tiledb
    FILES
        io/TileDBReader.cpp
    LINK_WITH
        ${TILEDB_LIBRARIES}
    INCLUDES
        ${TILEDB_INCLUDE_DIR}
        ${NLOHMANN_INCLUDE_DIR}
)

if (WIN32)
    target_compile_definitions(${reader_libname} PRIVATE -DNONMINMAX)
endif()

#
# TileDB Writer
#

PDAL_ADD_PLUGIN(writer_libname writer tiledb
    FILES
        io/TileDBWriter.cpp
    LINK_WITH
        ${TILEDB_LIBRARIES}
    INCLUDES
        ${TILEDB_INCLUDE_DIR}
        ${NLOHMANN_INCLUDE_DIR}
)

if (WIN32)
    target_compile_definitions(${writer_libname} PRIVATE -DNONMINMAX)
endif()

if (WITH_TESTS)

    # Need to fix this #2596
    IF (NOT APPLE)
        PDAL_ADD_TEST(pdal_io_tiledb_writer_test
            FILES
                test/TileDBWriterTest.cpp
            LINK_WITH
                ${writer_libname}
                ${TILEDB_LIBRARIES}
            INCLUDES
                ${TILEDB_INCLUDE_DIR}
                ${NLOHMANN_INCLUDE_DIR}
        )
    ENDIF()

    PDAL_ADD_TEST(pdal_io_tiledb_reader_test
        FILES
            test/TileDBReaderTest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
            ${TILEDB_LIBRARIES}
    )

if (WIN32)
    target_compile_definitions(pdal_io_tiledb_writer_test PRIVATE -DNONMINMAX)
    target_compile_definitions(pdal_io_tiledb_reader_test PRIVATE -DNONMINMAX)
endif()

endif()

=== debian/changelog ===
pdal (2.2.0+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 10 Sep 2020 09:12:02 +0200

pdal (2.2.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 09 Sep 2020 17:49:25 +0200

pdal (2.2.0~rc3+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 05 Sep 2020 06:42:31 +0200

pdal (2.2.0~rc2+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop spelling-errors.patch, applied upstream.
  * Drop obsolete missing-sources.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Sep 2020 05:55:30 +0200

pdal (2.2.0~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update lintian overrides.
  * Update pdal-config.1 manpage.
  * Rename library packages for SONAME bump.
  * Drop obsolete Breaks/Replaces.
  * Add python3-sphinxcontrib-{bibtex,spelling} build dependencies.
  * Drop patches applied upstream.
  * Add patch to fix spelling errors.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 Aug 2020 15:24:37 +0200

=== debian/control ===
Source: pdal
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper (>= 10~),
               bash-completion,
               chrpath,
               cmake (>= 3.5),
               gdal-bin,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgdal-dev (>= 2.2),
               libgeotiff-dev,
               libhdf5-dev,
               libjs-mathjax,
               liblaszip-dev,
               libpq-dev,
               libwebsocketpp-dev,
               libxerces-c-dev,
               libxml2-dev,
               libzstd-dev,
               pkg-kde-tools,
               python3-breathe,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-sphinxcontrib.bibtex,
               python3-sphinxcontrib.spelling,
               zlib1g-dev,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/pdal.git
Homepage: http://pdal.io/

Package: pdal
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL utilities.

Package: pdal-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: libpdal-dev,
          pdal
Description: Point Data Abstraction Library - documentation
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL documentation.

Package: libpdal-base12
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpdal-plugins
Description: Point Data Abstraction Library - libpdal_base
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_base shared library.

Package: libpdal-util12
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - libpdal_util
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_util shared library.

Package: libpdal-dev
Architecture: any
Section: libdevel
Depends: libpdal-base12 (= ${binary:Version}),
         libpdal-util12 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev,
         libgeos++-dev,
         libgeotiff-dev,
         liblaszip-dev,
         libproj-dev,
         libxml2-dev,
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library - development files
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL development files.

Package: libpdal-plugins
Architecture: any
Section: libs
Depends: libpdal-plugin-e57 (= ${binary:Version}),
         libpdal-plugin-faux (= ${binary:Version}),
         libpdal-plugin-hdf (= ${binary:Version}),
         libpdal-plugin-i3s (= ${binary:Version}),
         libpdal-plugin-icebridge (= ${binary:Version}),
         libpdal-plugin-pgpointcloud (= ${binary:Version}),
         ${misc:Depends}
Description: Point Data Abstraction Library - plugins
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This metapackage depends on the individual PDAL plugin packages.

Package: libpdal-plugin-e57
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - E57 plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the E57 plugin.

Package: libpdal-plugin-faux
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Faux plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Faux plugin.

Package: libpdal-plugin-hdf
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - HDF plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the HDF plugin.

Package: libpdal-plugin-i3s
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - I3S plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the I3S plugin.

Package: libpdal-plugin-icebridge
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Icebridge plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

CXXFLAGS += $(CPPFLAGS)

UPSTREAM_VERSION  = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

%:
	dh $@ --with pkgkde_symbolshelper,sphinxdoc

override_dh_clean:
	dh_clean debian/man/*.1

	$(RM) -r doc/html

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_INSTALL_LIBDIR=lib \
	                     -DBUILD_PLUGIN_E57=ON \
	                     -DBUILD_PLUGIN_HDF=ON \
	                     -DBUILD_PLUGIN_I3S=ON \
	                     -DBUILD_PLUGIN_ICEBRIDGE=ON \
	                     -DWITH_COMPLETION=ON

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

	sphinx-build doc/ doc/html/ && ln -s /usr/share/javascript/mathjax doc/html/_static/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Exclude tests:
	# - pgpointcloudtest, requires configured PostgreSQL database
	# - pdal_spatial_reference_test, fails sometimes
	(cd obj-* && ctest --force-new-ctest-process --output-on-failure --exclude-regex "pgpointcloudtest|pdal_spatial_reference_test" || echo "Ignoring test failures")
endif

override_dh_auto_install:
	dh_auto_install

	# Strip RPATH
	chrpath --delete debian/tmp/usr/lib/libpdal_plugin_*.so

	# Move pkg-config file to Multi-Arch path
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Remove empty directories
	rmdir $(CURDIR)/debian/*/usr/include/pdal/filters/private/csf
	rmdir $(CURDIR)/debian/*/usr/include/pdal/filters/private/miniball

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0
